#!/usr/bin/python3
import os
import time 
import re
from i2c_tool import i2c_tools

low=45
mid=55
high=65

temp_range = 3

off_mode = 0x00
low_mode = 0x8f
mid_mode = 0xbf
high_mode = 0xff
temp_mode = 0xff

fan_addr = 0x2f
register_addr = 0x30

status_mode = 0

def get_speed():
    try:
        txt = re.split("\n",os.popen("cat /etc/fan_speed.conf").read())
    except Exception as e:
        print(str(e))
        return False
    for i in range(5):
        if txt[i].find("temper_low=") != -1 :
            global low,mid,high
            low = int(re.split("=",txt[i])[1])
            mid = int(re.split("=",txt[i+1])[1])
            high = int(re.split("=",txt[i+2])[1])
            break

# def curcle(temp):
#     while True:
#         temp_value = float(get_temp())
#         time.sleep(3)
#         print("curcle!!!")
#         print("curcle temperature",temp_value)
#         if (temp_value - temp > temp_range) or (temp - temp_value > temp_range):
#             break

def get_temp():
    temp = os.popen("vcgencmd measure_temp").read()
    temp_value = re.split("=|'", temp)[1]
    return temp_value

def fan_mode():
    temp_value = float(get_temp())
    print("temperature",temp_value)
    global temp_mode
    if temp_value < low:
        mode = off_mode
    elif temp_value >= low and temp_value < mid:
        mode = low_mode
    elif temp_value >= mid and temp_value < high:
        mode = mid_mode
    else:
        mode = high_mode

    if temp_mode != mode :
        i2c_tools.write(fan_addr, register_addr, mode)
        temp_mode = mode
        # curcle(temp_value)


if __name__ == "__main__":
    i2c_tools.scan_i2c_bus(fan_addr)
    print("The fan is mounted on the bus",i2c_tools.i2c_bus)
    get_speed()
    print("temper_low=",low,"\ntemper_mid=",mid,"\ntemper_high=",high)
    while True:
        fan_mode()
        time.sleep(3)

