#!/bin/bash
function init()
{
	ls  /etc/fan_speed.conf  >/dev/null 2>&1
	if [ $? -ne 0 ]; then  
			#不存在就生成一个默认的文件
			touch ~/fan_speed.conf
            p=~/fan_speed.conf
            echo "#当CPU的温度小于temper_low,对应风扇关闭.
#当CPU的温度大于等于temper_low且小于temper_mid,对应风扇的风力为50%.
#当CPU的温度大于等于temper_mid且小于temper_high,对应风扇的风力为75%.
#当CPU的温度大于等于temper_high,对应风扇的风力为100%." > $p
			echo "temper_low=40" >> $p
			echo "temper_mid=60" >> $p
            echo "temper_high=70" >> $p
            sudo mv ~/fan_speed.conf /etc
	fi
    
}

function print_input()
{
    echo "Usage: "$0" -l [temper_low]  -m [temper_mid] -h [temper_high] "
}

function value_is_vaild()
{
    if [  $temper_high -le $temper_mid  -o \
          $temper_mid -le $temper_low  ]; then
        echo "temper_low needs to be less than temper_mid,\
        and temper_mid needs to be less than temper_high"
        exit 1
    fi

    if [ $temper_low -lt 0 ]; then
        echo "temper_low needs to be greater than 0"
        exit 1
    fi

    if [ $temper_high -gt 80 ]; then
        echo "temperhigh value needs to be less than 80"
        exit 1
    fi

}



if [ $# -ne 6 ] ; then
    print_input
    exit 1
fi
init
    while getopts ":l:m:h:" opt
    do 
        case $opt in
            l)
            temper_low=$OPTARG
            echo "temper_low=$temper_low"
            ;;
            m)
            temper_mid=$OPTARG
            echo "temper_mid=$temper_mid"
            ;;
            h)
            temper_high=$OPTARG
            echo "temper_high=$temper_high"
            ;;
            ?)
            print_input
            exit 1
            ;;
        esac
    done
    value_is_vaild

# sudo sed -i "s/temper_low = .*$/temper_low = $temper_low /g" /etc/fan_speed.conf
# sudo sed -i "s/temper_mid = .*$/temper_mid = $temper_mid /g" /etc/fan_speed.conf
# sudo sed -i "s/temper_high = .*$/temper_high = $temper_high /g" /etc/fan_speed.conf
# echo "Exe Success,Plese reboot to take effect"

sudo sed -i "s/temper_low=.*$/temper_low=$temper_low /g" /etc/fan_speed.conf
sudo sed -i "s/temper_mid=.*$/temper_mid=$temper_mid /g" /etc/fan_speed.conf
sudo sed -i "s/temper_high=.*$/temper_high=$temper_high /g" /etc/fan_speed.conf
echo "Exe Success,Plese reboot to take effect"